git add: respect core.filemode with unmerged entries
[gitweb.git] / git-tag.sh
index ecb9100e4b3a7d1ce0227fde447f675376aaf29a..1ff5b41e7f8671ccf7e2c6b25cedcfd1fbc2ea55 100755 (executable)
@@ -1,7 +1,7 @@
 #!/bin/sh
 # Copyright (c) 2005 Linus Torvalds
 
-USAGE='-l [<pattern>] | [-a | -s | -u <key-id>] [-f | -d | -v] [-m <msg>] <tagname> [<head>]'
+USAGE='[-n [<num>]] -l [<pattern>] | [-a | -s | -u <key-id>] [-f | -d | -v] [-m <msg>] <tagname> [<head>]'
 SUBDIRECTORY_OK='Yes'
 . git-sh-setup
 
@@ -13,36 +13,82 @@ message=
 username=
 list=
 verify=
+LINES=0
 while case "$#" in 0) break ;; esac
 do
     case "$1" in
     -a)
        annotate=1
+       shift
        ;;
     -s)
        annotate=1
        signed=1
+       shift
        ;;
     -f)
        force=1
+       shift
        ;;
-    -l)
-       case "$#" in
-       1)
-               set x . ;;
+    -n)
+        case "$#,$2" in
+       1,* | *,-*)
+               LINES=1         # no argument
+               ;;
+       *)      shift
+               LINES=$(expr "$1" : '\([0-9]*\)')
+               [ -z "$LINES" ] && LINES=1 # 1 line is default when -n is used
+               ;;
        esac
        shift
-       git rev-parse --symbolic --tags | sort | grep "$@"
-       exit $?
+       ;;
+    -l)
+       list=1
+       shift
+       case $# in
+       0)      PATTERN=
+               ;;
+       *)
+               PATTERN="$1"    # select tags by shell pattern, not re
+               shift
+               ;;
+       esac
+       git rev-parse --symbolic --tags | sort |
+           while read TAG
+           do
+               case "$TAG" in
+               *$PATTERN*) ;;
+               *)          continue ;;
+               esac
+               [ "$LINES" -le 0 ] && { echo "$TAG"; continue ;}
+               OBJTYPE=$(git cat-file -t "$TAG")
+               case $OBJTYPE in
+               tag)
+                       ANNOTATION=$(git cat-file tag "$TAG" |
+                               sed -e '1,/^$/d' |
+                               sed -n -e "
+                                       /^-----BEGIN PGP SIGNATURE-----\$/q
+                                       2,\$s/^/    /
+                                       p
+                                       ${LINES}q
+                               ")
+                       printf "%-15s %s\n" "$TAG" "$ANNOTATION"
+                       ;;
+               *)      echo "$TAG"
+                       ;;
+               esac
+           done
        ;;
     -m)
-       annotate=1
+       annotate=1
        shift
        message="$1"
        if test "$#" = "0"; then
            die "error: option -m needs an argument"
        else
+           message="$1"
            message_given=1
+           shift
        fi
        ;;
     -F)
@@ -53,22 +99,37 @@ do
        else
            message="$(cat "$1")"
            message_given=1
+           shift
        fi
        ;;
     -u)
        annotate=1
        signed=1
        shift
-       username="$1"
+       if test "$#" = "0"; then
+           die "error: option -u needs an argument"
+       else
+           username="$1"
+           shift
+       fi
        ;;
     -d)
-       shift
-       tag_name="$1"
-       tag=$(git-show-ref --verify --hash -- "refs/tags/$tag_name") ||
-               die "Seriously, what tag are you talking about?"
-       git-update-ref -m 'tag: delete' -d "refs/tags/$tag_name" "$tag" &&
-               echo "Deleted tag $tag_name."
-       exit $?
+       shift
+       had_error=0
+       for tag
+       do
+               cur=$(git-show-ref --verify --hash -- "refs/tags/$tag") || {
+                       echo >&2 "Seriously, what tag are you talking about?"
+                       had_error=1
+                       continue
+               }
+               git-update-ref -m 'tag: delete' -d "refs/tags/$tag" "$cur" || {
+                       had_error=1
+                       continue
+               }
+               echo "Deleted tag $tag."
+       done
+       exit $had_error
        ;;
     -v)
        shift
@@ -85,9 +146,10 @@ do
        break
        ;;
     esac
-    shift
 done
 
+[ -n "$list" ] && exit 0
+
 name="$1"
 [ "$name" ] || usage
 prev=0000000000000000000000000000000000000000
@@ -103,7 +165,10 @@ git-check-ref-format "tags/$name" ||
 object=$(git-rev-parse --verify --default HEAD "$@") || exit 1
 type=$(git-cat-file -t $object) || exit 1
 tagger=$(git-var GIT_COMMITTER_IDENT) || exit 1
-: ${username:=$(expr "z$tagger" : 'z\(.*>\)')}
+
+test -n "$username" ||
+       username=$(git-repo-config user.signingkey) ||
+       username=$(expr "z$tagger" : 'z\(.*>\)')
 
 trap 'rm -f "$GIT_DIR"/TAG_TMP* "$GIT_DIR"/TAG_FINALMSG "$GIT_DIR"/TAG_EDITMSG' 0
 
@@ -114,7 +179,7 @@ if [ "$annotate" ]; then
           echo "#" ) > "$GIT_DIR"/TAG_EDITMSG
         ${VISUAL:-${EDITOR:-vi}} "$GIT_DIR"/TAG_EDITMSG || exit
     else
-        echo "$message" >"$GIT_DIR"/TAG_EDITMSG
+        printf '%s\n' "$message" >"$GIT_DIR"/TAG_EDITMSG
     fi
 
     grep -v '^#' <"$GIT_DIR"/TAG_EDITMSG |
@@ -138,4 +203,3 @@ if [ "$annotate" ]; then
 fi
 
 git update-ref "refs/tags/$name" "$object" "$prev"
-